#TEMPLATE(hjXml, 'Dictionary to XML'), FAMILY('ABC', 'CW20')
#INCLUDE('hjXmlHandler.TPW')
#!-----------------------------------------------------------------------------
#!  X Symbols Dependent on %Application
#!  X Symbols Dependent on %File
#!  X Symbols Dependent on %Field
#!  X Symbols Dependent on %Relation
#!  X Symbols Dependent on %Key and %KeyOrder
#!  X Symbols Dependent on %Procedure
#!  X Symbols Dependent on %Module
#! NA Miscellaneous Symbols
#!  X Window Control Symbols
#!  X File Driver Symbols
#!  X Formula Symbols
#!  X File Schematic Symbols
#!  X Report Control Symbols
#! NA Expansion Symbols
#!  ? Symbols Dependent on %View
#!  X User defined Symbols
#!-----------------------------------------------------------------------------
#UTILITY(ApplicationToXml, 'Write Application to XML')
#!
#PROMPT('Output File', SAVEDIALOG('Output File', '*.*')), %pOutputFile, REQ
#PROMPT('Encoding', @s50), %pEncoding, DEFAULT('UTF-8')
#PROMPT('Application Info', CHECK), %pExportApplicationInfo, DEFAULT(%True)
#ENABLE(%pExportApplicationInfo)
  #PROMPT('Application Template Info', CHECK), %pExportApplicationTemplateInfo, DEFAULT(%True)
#ENDENABLE
#PROMPT('Module Info', CHECK), %pExportModuleInfo, DEFAULT(%True)
#PROMPT('Procedure Info', CHECK), %pExportProcedureInfo, DEFAULT(%True)
#ENABLE(%pExportProcedureInfo)
  #PROMPT('File Schematic Info', CHECK), %pExportFileSchematicInfo, DEFAULT(%True)
  #PROMPT('Window Info', CHECK), %pExportWindowInfo, DEFAULT(%True)
  #PROMPT('Report Info', CHECK), %pExportReportInfo, DEFAULT(%True)
  #PROMPT('Formula Info', CHECK), %pExportFormulaInfo, DEFAULT(%True)
  #PROMPT('Procedure Template Info', CHECK), %pExportProcedureTemplateInfo, DEFAULT(%True)
#ENDENABLE
#BOXED('Unhandled Templates')
  #PROMPT('Log File', SAVEDIALOG('Log File', '*.*')), %pLogFile, DEFAULT('hjXmlLog.txt')
#ENDBOXED
#INSERT(%Notice)
#!
#PREPARE
  #SET(%pOutputFile, %Application & '.xml')
  #SET(%pDateModified, DEFORMAT('August 9, 2005', @D4))
#ENDPREPARE
#!
#DECLARE(%UsedTemplates), MULTI, UNIQUE
#DECLARE(%UsedTemplateIsHandled, %UsedTemplates)
#CREATE(%pOutputFile)
<?xml version="1.0" %(%GetEncoding(%pEncoding))?>
<Application>
  #MESSAGE('Processing Application Info', 1)
  #IF(%pExportApplicationInfo)
  #INSERT(%GetApplicationInfo)
    #IF(%pExportApplicationTemplateInfo)
  <Templates>
      #FOR(%ApplicationTemplate)
    <Template>
      #INSERT(%GetApplicationTemplateInfo)
    </Template>
      #ENDFOR
  </Templates>
    #ENDIF
  #ENDIF
  #MESSAGE('Processing Module Info', 1)
  #IF(%pExportModuleInfo)
  <Modules>
    #FOR(%Module)
    <Module>
      #INSERT(%GetModuleInfo)
    </Module>
    #ENDFOR
  </Modules>
  #ENDIF
  #IF(%pExportProcedureInfo)
  <Procedures>
    #DECLARE(%nProcedure)
    #SET(%nProcedure, 0)
    #EQUATE(%nProcedures, ITEMS(%Procedure))
    #FOR(%Procedure)
      #SET(%nProcedure, %nProcedure + 1)
      #MESSAGE('Processing ' & %nProcedure & ' of ' & %nProcedures & ' (' & %Procedure & ')', 1)
    <Procedure>
      #INSERT(%GetProcedureInfo)
      #IF(%pExportFileSchematicInfo)
      <FileSchematic>
        #INSERT(%GetFileSchematicInfo)
      </FileSchematic>
      #ENDIF
      #IF(%pExportWindowInfo)
      <Window>
        #INSERT(%GetWindowInfo)
      </Window>
      #ENDIF
      #IF(%pExportReportInfo)
      <Report>
        #INSERT(%GetReportInfo)
      </Report>
      #ENDIF
      #IF(%pExportFormulaInfo)
      <Formulas>
        #FOR(%Formula)
        <Formula>
          #INSERT(%GetFormulaInfo)
        </Formula>
        #ENDFOR
      </Formulas>
      #ENDIF
      #IF(%pExportProcedureTemplateInfo)
      <Templates>
        #FOR(%ActiveTemplate)
        <Template>
          #INSERT(%GetProcedureTemplateInfo)
        </Template>
        #ENDFOR
      </Templates>
      #ENDIF
    </Procedure>
    #ENDFOR
  </Procedures>
  #ENDIF
</Application>
#CLOSE(%pOutputFile)
#IF(%pLogFile <> '')
  #CREATE(%pLogFile)
    #FOR(%UsedTemplates), WHERE(NOT %UsedTemplateIsHandled)
%UsedTemplates
    #ENDFOR
  #CLOSE(%pLogFile)
#ENDIF
#!-----------------------------------------------------------------------------
#GROUP(%GetFileSchematicInfo)
<PrimaryFile>
#IF(%Primary)
  %(%WriteTag('Label', %GetStringValue(%Primary)))
  %(%WriteTag('Key', %GetStringValue(%PrimaryKey)))
  %(%WriteTag('Instance', %PrimaryInstance))
  <SecondaryFiles>
  #FOR(%Secondary)
    <SecondaryFile>
      %(%WriteTag('Label', %GetStringValue(%Secondary)))
      %(%WriteTag('RelatedTo', %GetStringValue(%SecondaryTo)))
      %(%WriteTag('RelationType', %GetStringValue(%SecondaryType)))
      %(%WriteTag('IsCustomJoin', %GetBooleanValue(%SecondaryCustomJoin)))
      %(%WriteTag('CustomJoinExpression', %GetStringValue(%SecondaryCustomText)))
      %(%WriteTag('IsInnerJoin', %GetBooleanValue(%SecondaryInner)))
    </SecondaryFile>
  #ENDFOR
  </SecondaryFiles>
#ENDIF
</PrimaryFile>
<OtherFiles>
#FOR(%OtherFiles)
  %(%WriteTag('OtherFile', %GetStringValue(%OtherFiles)))
#ENDFOR
</OtherFiles>
#!
#GROUP(%GetFormulaInfo)
%(%WriteTag('ReturnField', %GetStringValue(%Formula)))
%(%WriteTag('Description', %GetStringValue(%FormulaDescription)))
%(%WriteTag('Class', %GetStringValue(%FormulaClass)))
%(%WriteTag('Instance', %FormulaInstance))
<Expressions>
#FOR(%FormulaExpression)
  <Expression>
    %(%WriteTag('Expression', %GetStringValue(%FormulaExpression)))
    %(%WriteTag('Type', %GetStringValue(%FormulaExpressionType)))
    %(%WriteTag('TrueLineNumber', %FormulaExpressionTrue))
    %(%WriteTag('FalseLineNumber', %FormulaExpressionFalse))
    %(%WriteTag('OfLineNumber', %FormulaExpressionOf))
    %(%WriteTag('AssignmentLineNumber', %FormulaExpressionCase))
  </Expression>
#ENDFOR
</Expressions>
#!
#GROUP(%GetProcedureTemplateInfo)
%(%WriteTag('Name', %GetStringValue(%ActiveTemplate)))
<Instances>
#FOR(%ActiveTemplateInstance)
  <Instance>
    %(%WriteTag('InstanceNumber', %ActiveTemplateInstance))
    %(%WriteTag('OwnerInstance', %ActiveTemplateOwnerInstance))
    %(%WriteTag('ParentInstance', %ActiveTemplateParentInstance))
    %(%WriteTag('PrimaryInstance', %ActiveTemplatePrimaryInstance))
    %(%WriteTag('Description', %GetStringValue(%ActiveTemplateInstanceDescription)))
    %(%WriteTag('Type', %GetStringValue(%ActiveTemplateType)))
    %(%HandleProcedureTemplate(%ActiveTemplate))
  </Instance>
#ENDFOR
</Instances>
#!
#GROUP(%GetApplicationTemplateInfo)
%(%WriteTag('Name', %GetStringValue(%ApplicationTemplate)))
<Instances>
#FOR(%ApplicationTemplateInstance)
  <Instance>
    %(%WriteTag('InstanceNumber', %ApplicationTemplateInstance))
    %(%WriteTag('Description', %GetStringValue(%ApplicationTemplateInstanceDescription)))
    %(%WriteTag('ParentInstance', %ApplicationTemplateParentInstance))
    %(%WriteTag('PrimaryInstance', %ApplicationTemplatePrimaryInstance))
    %(%HandleApplicationTemplate(%ApplicationTemplate))
  </Instance>
#ENDFOR
</Instances>
#!
#GROUP(%GetApplicationInfo)
%(%WriteTag('Name', %GetStringValue(%Application)))
%(%WriteTag('IsDebugMode', %GetBooleanValue(%ApplicationDebug)))
%(%WriteTag('IsCompiledLocal', %GetBooleanValue(%ApplicationLocalLibrary)))
%(%WriteTag('Target', %GetStringValue(%ProjectTarget)))
%(%WriteTag('Is32Bit', %GetBooleanValue(%Target32)))
%(%WriteTag('HasChangedDictionary', %GetBooleanValue(%DictionaryChanged)))
%(%WriteTag('HasChangedRegistry', %GetBooleanValue(%RegistryChanged)))
%(%WriteTag('DateCreated', %GetDateValue(%ProgramDateCreated)))
%(%WriteTag('DateChanged', %GetDateValue(%ProgramDateChanged)))
%(%WriteTag('TimeCreated', %GetTimeValue(%ProgramTimeCreated)))
%(%WriteTag('TimeChanged', %GetTimeValue(%ProgramTimeChanged)))
%(%WriteTag('FirstProcedure', %GetStringValue(%FirstProcedure)))
%(%WriteTag('HelpFile', %GetStringValue(%HelpFile)))
%(%WriteTag('OutputExtension', %GetStringValue(%ProgramExtension)))
%(%WriteTag('DictionaryFileName', %GetStringValue(%DictionaryFile)))
%(%WriteTag('ProgramModule', %GetStringValue(%Program)))
<GlobalData>
  %(%WriteTag('CreateLocalMap', %GetBooleanValue(%CreateLocalMap)))
  %(%WriteTag('QuickProcedure', %GetStringValue(%QuickProcedure)))
#! IGNORED  %(%WriteTag('', %GetStringValue(%EditProcedure)))
#! IGNORED  %(%WriteTag('', %GetStringValue(%EditFilename)))
#FOR(%GlobalData)
  <Variable>
    %(%WriteTag('Name', %GetStringValue(%GlobalData)))
    %(%WriteTag('IsInDictionary', %GetBooleanValue(%GlobalDataInDictionary)))
    %(%WriteTag('Statement', %GetStringValue(%GlobalDataStatement)))
    %(%WriteTag('IsGeneratedLast', %GetBooleanValue(%GlobalDataLast)))
    %(%WriteTag('Indent', %GlobalDataLevel))
    %(%WriteTag('UserOptions', %GetUserOptions(%GlobalDataUserOptions)))
  </Variable>
#ENDFOR
</GlobalData>
#!
#GROUP(%GetModuleInfo)
%(%WriteTag('Name', %GetStringValue(%Module)))
%(%WriteTag('Description', %GetStringValue(%ModuleDescription)))
%(%WriteTag('Language', %GetStringValue(%ModuleLanguage)))
%(%WriteTag('Template', %GetStringValue(%ModuleTemplate)))
%(%WriteTag('HasChanged', %GetBooleanValue(%ModuleChanged)))
%(%WriteTag('IsExternal', %GetBooleanValue(%ModuleExternal)))
%(%WriteTag('IsReadonly', %GetBooleanValue(%ModuleReadOnly)))
%(%WriteTag('FileExtension', %GetStringValue(%ModuleExtension)))
%(%WriteTag('FileName', %GetStringValue(%ModuleBase)))
%(%WriteTag('IncludeFileName', %GetStringValue(%ModuleInclude)))
<Procedures>
#FOR(%ModuleProcedure)
  %(%WriteTag('Procedure', %GetStringValue(%ModuleProcedure)))
#ENDFOR
</Procedures>
<ModuleData>
#FOR(%ModuleData)
  <Variable>
    %(%WriteTag('Name', %GetStringValue(%ModuleData)))
    %(%WriteTag('Statement', %GetStringValue(%ModuleDataStatement)))
    %(%WriteTag('UserOptions', %GetUserOptions(%ModuleDataUserOptions)))
  </Variable>
#ENDFOR
</ModuleData>
#!
#GROUP(%GetProcedureInfo)
%(%WriteTag('Name', %GetStringValue(%Procedure)))
%(%WriteTag('IsTodo', %GetBooleanValue(%ProcedureToDo)))
%(%WriteTag('Type', %GetStringValue(%ProcedureType)))
%(%WriteTag('ReturnType', %GetStringValue(%ProcedureReturnType)))
%(%WriteTag('DateCreated', %GetDateValue(%ProcedureDateCreated)))
%(%WriteTag('DateChanged', %GetDateValue(%ProcedureDateChanged)))
%(%WriteTag('TimeCreated', %GetTimeValue(%ProcedureTimeCreated)))
%(%WriteTag('TimeChanged', %GetTimeValue(%ProcedureTimeChanged)))
%(%WriteTag('IsReadonly', %GetBooleanValue(%ProcedureReadOnly)))
%(%WriteTag('IsGlobal', %GetBooleanValue(%ProcedureIsGlobal)))
%(%WriteTag('Prototype', %GetStringValue(%Prototype)))
%(%WriteTag('Template', %GetStringValue(%ProcedureTemplate)))
%(%WriteTag('Description', %GetStringValue(%ProcedureDescription)))
%(%WriteTag('Category', %GetStringValue(%ProcedureCategory)))
%(%WriteTag('IsExported', %GetBooleanValue(%ProcedureExported)))
%(%WriteTag('LongDescription', %GetStringValue(%ProcedureLongDescription)))
%(%WriteTag('Language', %GetStringValue(%ProcedureLanguage)))
<Procedures>
#FOR(%ProcedureCalled)
  %(%WriteTag('Procedure', %GetStringValue(%ProcedureCalled)))
#ENDFOR
</Procedures>
<LocalData>
#FOR(%LocalData)
  <Variable>
    %(%WriteTag('Name', %GetStringValue(%LocalData)))
    %(%WriteTag('Statement', %GetStringValue(%LocalDataStatement)))
    %(%WriteTag('Description', %GetStringValue(%LocalDataDescription)))
    %(%WriteTag('Header', %GetStringValue(%LocalDataHeader)))
    %(%WriteTag('Picture', %GetStringValue(%LocalDataPicture)))
    %(%WriteTag('Justification', %GetStringValue(%LocalDataJustType)))
    %(%WriteTag('JustificationOffset', %LocalDataJustIndent))
    %(%WriteTag('FormatWidth', %LocalDataFormatWidth))
    %(%WriteTag('UserOptions', %GetUserOptions(%LocalDataUserOptions)))
  </Variable>
#ENDFOR
</LocalData>
#!
#GROUP(%GetWindowInfo)
%(%WriteTag('Label', %GetStringValue(%Window)))
%(%WriteTag('Statement', %GetStringValue(%WindowStatement)))
%(%WriteTag('MenuBarStatement', %GetStringValue(%MenuBarStatement)))
%(%WriteTag('ToolBarStatement', %GetStringValue(%ToolbarStatement)))
#! IGNORED  <Events>
#! IGNORED  #FOR(%WindowEvent)
#! IGNORED    %(%WriteTag('Event', %GetStringValue(%WindowEvent)))
#! IGNORED  #ENDFOR
#! IGNORED  </Events>
<Controls>
  #FOR(%Control)
  <Control>
    %(%WriteTag('Label', %GetStringValue(%Control)))
    %(%WriteTag('Field', %GetStringValue(%ControlUse)))
    %(%WriteTag('Type', %GetStringValue(%ControlType)))
    %(%WriteTag('Template', %GetStringValue(%ControlTemplate)))
    %(%WriteTag('IsInToolbar', %GetBooleanValue(%ControlTool)))
    %(%WriteTag('Parent', %GetStringValue(%ControlParent)))
    %(%WriteTag('ParentType', %GetStringValue(%ControlParentType)))
    %(%WriteTag('ParentTab', %GetStringValue(%ControlParentTab)))
    %(%WriteTag('Parameter', %GetStringValue(%ControlParameter)))
    %(%WriteTag('HasIcon', %GetBooleanValue(%ControlHasIcon)))
    %(%WriteTag('HasColor', %GetBooleanValue(%ControlHasColor)))
    %(%WriteTag('HasStyle', %GetBooleanValue(%ControlHasStyle)))
    %(%WriteTag('HasTooltip', %GetBooleanValue(%ControlHasTip)))
    %(%WriteTag('IsTree', %GetBooleanValue(%ControlHasTree)))
    %(%WriteTag('DefaultWidth', %ControlDefaultWidth))
    %(%WriteTag('DefaultHeight', %ControlDefaultHeight))
    %(%WriteTag('IsInMenu', %GetBooleanValue(%ControlMenu)))
    %(%WriteTag('Indent', %ControlIndent))
    %(%WriteTag('TemplateInstance', %ControlInstance))
    %(%WriteTag('OriginalLabel', %GetStringValue(%ControlOriginal)))
    %(%WriteTag('DataSource', %GetStringValue(%ControlFrom)))
#! IGNORED    <Events>
#! IGNORED    #FOR(%ControlEvent)
#! IGNORED      %(%WriteTag('Event', %GetStringValue(%ControlEvent)))
#! IGNORED    #ENDFOR
#! IGNORED    </Events>
#! IGNORED    %(%WriteTag('', %GetStringValue(%ControlStatement)))
    %(%WriteTag('Statement', %GetStringValue(%ControlUnsplitStatement)))
    %(%WriteTag('ToolBarStatement', %GetStringValue(%ControlToolBar)))
    %(%WriteTag('MenuBarStatement', %GetStringValue(%ControlMenuBar)))
#!    <Keycodes>
#!    #FOR(%ControlAlert)
#! Bug?      %(%WriteTag('Keycode', %GetStringValue(%ControlAlert)))
#!    #ENDFOR
#!    </Keycodes>
    <Fields>
    #FOR(%ControlField)
      <Field>
        %(%WriteTag('Label', %GetStringValue(%ControlField)))
        %(%WriteTag('HasIcon', %GetBooleanValue(%ControlFieldHasIcon)))
        %(%WriteTag('HasColor', %GetBooleanValue(%ControlFieldHasColor)))
        %(%WriteTag('IsTree', %GetBooleanValue(%ControlFieldHasTree)))
        %(%WriteTag('HasLocator', %GetBooleanValue(%ControlFieldHasLocator)))
        %(%WriteTag('HasTooltip', %GetBooleanValue(%ControlFieldHasTip)))
        %(%WriteTag('DefaultTooltip', %GetStringValue(%ControlFieldDefaultTip)))
        %(%WriteTag('Picture', %GetStringValue(%ControlFieldPicture)))
        %(%WriteTag('Header', %GetStringValue(%ControlFieldHeader)))
        %(%WriteTag('Format', %GetStringValue(%ControlFieldFormat)))
      </Field>
    #ENDFOR
    </Fields>
  </Control>
  #ENDFOR
</Controls>
#!
#GROUP(%GetReportInfo)
%(%WriteTag('Label', %GetStringValue(%Report)))
%(%WriteTag('Statement', %GetStringValue(%ReportStatement)))
<Controls>
  #FOR(%ReportControl)
  <Control>
    %(%WriteTag('Label', %GetStringValue(%ReportControl)))
    %(%WriteTag('Field', %GetStringValue(%ReportControlUse)))
    %(%WriteTag('Statement', %GetStringValue(%Unsplit(%ReportControlStatement))))
    %(%WriteTag('Type', %GetStringValue(%ReportControlType)))
    %(%WriteTag('Template', %GetStringValue(%ReportControlTemplate)))
    %(%WriteTag('Ident', %GetStringValue(%ReportControlIndent)))
    %(%WriteTag('TemplateInstance', %GetStringValue(%ReportControlInstance)))
    %(%WriteTag('OriginalLabel', %GetStringValue(%ReportControlOriginal)))
    #! ?  %(%WriteTag('', %GetStringValue(%ReportControlLabel)))
    <Fields>
    #FOR(%ReportControlField)
      %(%WriteTag('Field', %GetStringValue(%ReportControlField)))
    #ENDFOR
    </Fields>
  </Control>
  #ENDFOR
</Controls>
#!-----------------------------------------------------------------------------
#UTILITY(DictionaryToXml, 'Write Dictionary to XML')
#! TODO
#!   Normalize whatever needs to be normalized
#!   'Options' Stuff
#!   File      - Trigger Stuff
#!   Key       - KeyOrder Stuff
#!   Field     - Choices Stuff
#!
#PROMPT('Output File', SAVEDIALOG('Output File', '*.*')), %pOutputFile, REQ
#PROMPT('Encoding', @s50), %pEncoding, DEFAULT('UTF-8')
#PROMPT('Dictionary Info', CHECK), %pExportDictionaryInfo, DEFAULT(%True)
#PROMPT('File Info', CHECK), %pExportFileInfo, DEFAULT(%True)
#PROMPT('Key Info', CHECK), %pExportKeyInfo, DEFAULT(%True)
#PROMPT('Field Info', CHECK), %pExportFieldInfo, DEFAULT(%True)
#PROMPT('Relation Info', CHECK), %pExportRelationInfo, DEFAULT(%True)
#PROMPT('File Driver Info', CHECK), %pFileDriverInfo
#INSERT(%Notice)
#!
#PREPARE
  #SET(%pOutputFile, %DictionaryFile & '.xml')
  #SET(%pDateModified, DEFORMAT('August 1, 2005', @D4))
#ENDPREPARE
#!
#DECLARE(%Groups), MULTI, UNIQUE
#EQUATE(%nFiles, ITEMS(%File))
#DECLARE(%nFile)
#SET(%nFile, 0)
#CREATE(%pOutputFile)
<?xml version="1.0" %(%GetEncoding(%pEncoding))?>
<Dictionary>
  #IF(%pExportDictionaryInfo)
  #INSERT(%GetDictionaryInfo)
  #ENDIF
  <Files>
  #FOR(%File)
    #SET(%nFile, %nFile + 1)
    #MESSAGE('Processing ' & %nFile & ' of ' & %nFiles & ' (' & %File & ')', 1)
    <File>
      %(%WriteTag('Label', %GetStringValue(%File)))
    #IF(%pExportFileInfo)
      #INSERT(%GetFileInfo)
    #ENDIF
    #IF(%pExportKeyInfo)
      <Keys>
      #FOR(%Key)
        <Key>
          #INSERT(%GetKeyInfo)
        </Key>
      #ENDFOR
      </Keys>
    #ENDIF
    #IF(%pExportFieldInfo)
      <Fields>
      #FOR(%Field)
        #IF(NOT %FieldID)
          #POP(%Groups)
        #ELSE
        <Field>
          #INSERT(%GetFieldInfo)
        </Field>
          #IF(%FieldType = 'GROUP')
            #ADD(%Groups, %Field)
          #ENDIF
        #ENDIF
      #ENDFOR
      </Fields>
    #ENDIF
    #IF(%pExportRelationInfo)
      <Relations>
      #FOR(%Relation)
        <Relation>
          #INSERT(%GetRelationInfo)
        </Relation>
      #ENDFOR
      </Relations>
    #ENDIF
    </File>
  #ENDFOR
  </Files>
  #IF(%pFileDriverInfo)
  <FileDrivers>
    #FOR(%Driver)
      <FileDriver>
        #INSERT(%GetFileDriverInfo)
      </FileDriver>
    #ENDFOR
  </FileDrivers>
  #ENDIF
</Dictionary>
#CLOSE(%pOutputFile)
#!-----------------------------------------------------------------------------
#GROUP(%GetDictionaryInfo)
%(%WriteTag('FileName', %GetStringValue(%DictionaryFile)))
%(%WriteTag('QuickOptions', %GetQuickOptions(%DictionaryQuickOptions)))
%(%WriteTag('UserOptions', %GetUserOptions(%DictionaryUserOptions)))
%(%WriteTag('ToolOptions', %GetToolOptions(%DictionaryToolOptions)))
%(%WriteTag('Description', %GetStringValue(%DictionaryDescription)))
%(%WriteTag('Version', %GetVersionInfo(%DictionaryVersion)))
%(%WriteTag('TimeCreated', %GetTimeValue(%DictionaryTimeCreated)))
%(%WriteTag('DateCreated', %GetDateValue(%DictionaryDateCreated)))
%(%WriteTag('TimeChanged', %GetTimeValue(%DictionaryTimeChanged)))
%(%WriteTag('DateChanged', %GetDateValue(%DictionaryDateChanged)))
#!
#GROUP(%GetFileInfo)
%(%WriteTag('Is32BitOnly', %GetBooleanValue(%File32BitOnly)))
%(%WriteTag('AllowBind', %GetBooleanValue(%FileBindable)))
%(%WriteTag('AllowCreate', %GetBooleanValue(%FileCreate)))
%(%WriteTag('Description', %GetStringValue(%FileDescription)))
%(%WriteTag('Driver', %GetStringValue(%FileDriver)))
%(%WriteTag('DriverParameter', %GetStringValue(%FileDriverParameter)))
%(%WriteTag('IsEncrypted', %GetBooleanValue(%FileEncrypt)))
%(%WriteTag('IsExternal', %GetBooleanValue(%FileExternal)))
%(%WriteTag('ExternalModule', %GetStringValue(%FileExternalModule)))
%(%WriteTag('Ident', %FileIdent))
%(%WriteTag('LastModified', %FileLastModified))
%(%WriteTag('LongDescription', %GetStringValue(%FileLongDesc)))
%(%WriteTag('Name', %GetStringValue(%FileName)))
%(%WriteTag('IsOEM', %GetBooleanValue(%FileOEM)))
%(%WriteTag('Owner', %GetStringValue(%FileOwner)))
%(%WriteTag('Prefix', %GetStringValue(%FilePrefix)))
%(%WriteTag('PrimaryKey', %GetStringValue(%FilePrimaryKey)))
%(%WriteTag('QuickOptions', %GetQuickOptions(%FileQuickOptions)))
%(%WriteTag('AllowReclaim', %GetBooleanValue(%FileReclaim)))
#! IGNORED  %(%WriteTag('Statement', %GetStringValue(%FileStatement)))
#! IGNORED  %(%WriteTag('Struct', %GetStringValue(%FileStruct)))
#! IGNORED  %(%WriteTag('StructEnd', %GetStringValue(%FileStructEnd)))
#! IGNORED  %(%WriteTag('StructRec', %GetStringValue(%FileStructRec)))
#! IGNORED  %(%WriteTag('StructRecEnd', %GetStringValue(%FileStructRecEnd)))
%(%WriteTag('IsThreaded', %GetBooleanValue(%FileThreaded)))
#!  %(%WriteTag('TriggerBeforeInsert', %FileTriggerBeforeInsert))
#!  %(%WriteTag('TriggerAfterInsert', %FileTriggerAfterInsert))
#!  %(%WriteTag('TriggerBeforeUpdate', %FileTriggerBeforeUpdate))
#!  %(%WriteTag('TriggerAfterUpdate', %FileTriggerAfterUpdate))
#!  %(%WriteTag('TriggerBeforeDelete', %FileTriggerBeforeDelete))
#!  %(%WriteTag('TriggerAfterDelete', %FileTriggerAfterDelete))
#!  %(%WriteTag('TriggerDataInitialValue', %FileTriggerDataInitialValue))
%(%WriteTag('Type', %GetStringValue(%FileType)))
%(%WriteTag('UserOptions', %GetUserOptions(%FileUserOptions)))
%(%WriteTag('AliasedFile', %GetStringValue(%AliasFile)))
#!
#GROUP(%GetKeyInfo)
  #IF(%True)
%(%WriteTag('Label', %GetStringValue(%Key)))
%(%WriteTag('Ident', %KeyIdent))
%(%WriteTag('Description', %GetStringValue(%KeyDescription)))
%(%WriteTag('LongDescription', %GetStringValue(%KeyLongDesc)))
%(%WriteTag('File', %GetStringValue(%KeyFile)))
%(%WriteTag('ID', %GetStringValue(%KeyID)))
%(%WriteTag('Type', %GetStringValue(%KeyIndex)))
%(%WriteTag('Name', %GetStringValue(%KeyName)))
%(%WriteTag('AutoNumberedField', %GetStringValue(%KeyAuto)))
%(%WriteTag('AllowDuplicate', %GetBooleanValue(%KeyDuplicate)))
%(%WriteTag('AllowNull', %GetBooleanValue(CHOOSE(%KeyExcludeNulls = '1', '', '1'))))
%(%WriteTag('IsCaseSensitive', %GetBooleanValue(CHOOSE(%KeyNoCase = '1', '', '1'))))
%(%WriteTag('IsPrimary', %GetBooleanValue(%KeyPrimary)))
#! IGNORED    %(%WriteTag('Struct', %GetStringValue(%KeyStruct)))
#! IGNORED    %(%WriteTag('Statement', %GetStringValue(%KeyStatement)))
<Fields>
#FOR(%KeyField)
  <Field>
    %(%WriteTag('Name', %GetStringValue(%KeyField)))
    %(%WriteTag('Sequence', %GetStringValue(%KeyFieldSequence)))
  </Field>
#ENDFOR
</Fields>
%(%WriteTag('QuickOptions', %GetQuickOptions(%KeyQuickOptions)))
%(%WriteTag('UserOptions', %GetUserOptions(%KeyUserOptions)))
%(%WriteTag('ToolOptions', %GetToolOptions(%KeyToolOptions)))
  #ELSE
%(%WriteTag('Label', %GetStringValue(%KeyOrder)))
%(%WriteTag('Ident', %KeyOrderIdent))
%(%WriteTag('Description', %GetStringValue(%KeyOrderDescription)))
%(%WriteTag('LongDescription', %GetStringValue(%KeyOrderLongDesc)))
%(%WriteTag('File', %GetStringValue(%KeyOrderFile)))
%(%WriteTag('ID', %GetStringValue(%KeyOrderID)))
%(%WriteTag('Type', %GetStringValue(%KeyOrderIndex)))
%(%WriteTag('Name', %GetStringValue(%KeyOrderName)))
%(%WriteTag('AutoNumberedField', %GetStringValue(%KeyOrderAuto)))
%(%WriteTag('AllowDuplicate', %GetBooleanValue(%KeyOrderDuplicate)))
%(%WriteTag('AllowNull', %GetBooleanValue(%KeyOrderExcludeNulls)))
%(%WriteTag('IsCaseSensitive', %GetBooleanValue(%KeyOrderNoCase)))
%(%WriteTag('IsPrimary', %GetBooleanValue(%KeyOrderPrimary)))
#! IGNORED    %(%WriteTag('Struct', %GetStringValue(%KeyOrderStruct)))
#! IGNORED    %(%WriteTag('Statement', %GetStringValue(%KeyOrderStatement)))
%(%WriteTag('QuickOptions', %GetQuickOptions(%KeyOrderQuickOptions)))
%(%WriteTag('UserOptions', %GetUserOptions(%KeyOrderUserOptions)))
%(%WriteTag('ToolOptions', %GetToolOptions(%KeyOrderToolOptions)))
  #ENDIF
#!
#GROUP(%GetFieldInfo)
%(%WriteTag('Index', INSTANCE(%Field)))
%(%WriteTag('Label', %GetStringValue(%Field)))
%(%WriteTag('Parent', %GetStringValue(%Groups)))
%(%WriteTag('Ident', %FieldIdent))
%(%WriteTag('Description', %GetStringValue(%FieldDescription)))
%(%WriteTag('LongDescription', %GetStringValue(%FieldLongDesc)))
%(%WriteTag('File', %GetStringValue(%FieldFile)))
%(%WriteTag('ID', %GetStringValue(%FieldID)))
%(%WriteTag('DisplayPicture', %GetStringValue(%FieldDisplayPicture)))
#! IGNORED  %(%WriteTag('RecordPicture', %GetStringValue(%FieldRecordPicture)))
%(%WriteTag('Dimension1', %FieldDimension1))
%(%WriteTag('Dimension2', %FieldDimension2))
%(%WriteTag('Dimension3', %FieldDimension3))
%(%WriteTag('Dimension4', %FieldDimension4))
%(%WriteTag('HelpID', %GetStringValue(%FieldHelpID)))
%(%WriteTag('Name', %GetStringValue(%FieldName)))
%(%WriteTag('RangeLow', %GetStringValue(%FieldRangeLow)))
%(%WriteTag('RangeHigh', %GetStringValue(%FieldRangeHigh)))
%(%WriteTag('Type', %GetStringValue(%FieldType)))
%(%WriteTag('Places', %FieldPlaces))
%(%WriteTag('MemoSize', %FieldMemoSize))
%(%WriteTag('IsBinaryMemo', %GetBooleanValue(%FieldMemoImage)))
%(%WriteTag('Initial', %GetStringValue(%FieldInitial)))
%(%WriteTag('Lookup', %GetStringValue(%FieldLookup)))
%(%WriteTag('Over', %GetStringValue(EXTRACT(%FieldStruct, 'OVER', 1))))
#! IGNORED  %(%WriteTag('Struct', %GetStringValue(%FieldStruct)))
#! IGNORED  %(%WriteTag('Statement', %GetStringValue(%FieldStatement)))
%(%WriteTag('Header', %GetStringValue(%FieldHeader)))
#! IGNORED  %(%WriteTag('Picture', %GetStringValue(%FieldPicture)))
%(%WriteTag('Justification', %GetStringValue(%FieldJustType)))
%(%WriteTag('JustificationOffset', %FieldJustIndent))
%(%WriteTag('FormatWidth', %FieldFormatWidth))
<ScreenControls>
#FOR(%FieldScreenControl)
  <ScreenControl>
    %(%WriteTag('Control', %GetStringValue(%FieldScreenControl)))
    %(%WriteTag('Width', %FieldScreenControlWidth))
    %(%WriteTag('Height', %FieldScreenControlHeight))
  </ScreenControl>
#ENDFOR
</ScreenControls>
<ReportControls>
#FOR(%FieldScreenControl)
  <ReportControl>
    %(%WriteTag('Control', %GetStringValue(%FieldReportControl)))
    %(%WriteTag('Width', %FieldReportControlWidth))
    %(%WriteTag('Height', %FieldReportControlHeight))
  </ReportControl>
#ENDFOR
</ReportControls>
%(%WriteTag('Validation', %GetStringValue(%FieldValidation)))
#!  %(%WriteTag('', %FieldChoices))
#!  %(%WriteTag('', %FieldValues))
%(%WriteTag('TrueValue', %GetStringValue(%FieldTrueValue)))
%(%WriteTag('FalseValue', %GetStringValue(%FieldFalseValue)))
#!  %(%WriteTag('', %FieldDisplayChoices))
%(%WriteTag('QuickOptions', %GetQuickOptions(%FieldQuickOptions)))
%(%WriteTag('UserOptions', %GetUserOptions(%FieldUserOptions)))
%(%WriteTag('ToolOptions', %GetToolOptions(%FieldToolOptions)))
#!
#GROUP(%GetRelationInfo)
%(%WriteTag('RelatedFile', %GetStringValue(%Relation)))
%(%WriteTag('RelatedFilePrefix', %GetStringValue(%RelationPrefix)))
%(%WriteTag('RelatedFileAliasedFile', %GetStringValue(%RelationAlias)))
%(%WriteTag('Type', %GetStringValue(%FileRelationType)))
%(%WriteTag('RelatedKey', %GetStringValue(%RelationKey)))
%(%WriteTag('RelatedFilePrimaryKey', %GetStringValue(%RelationPrimaryKey)))
%(%WriteTag('LinkingKey', %GetStringValue(%FileKey)))
%(%WriteTag('RelatedFileDriver', %GetStringValue(%RelationDriver)))
%(%WriteTag('DeleteContraint', %GetStringValue(%RelationConstraintDelete)))
%(%WriteTag('UpdateContraint', %GetStringValue(%RelationConstraintUpdate)))
#! IGNORED  <RelationKeyFields>
#! IGNORED  #FOR(%RelationKeyField)
#! IGNORED    <RelationKeyField>
#! IGNORED      %(%WriteTag('Field', %RelationKeyField))
#! IGNORED      %(%WriteTag('FieldLink', %RelationKeyFieldLink))
#! IGNORED    </RelationKeyField>
#! IGNORED  #ENDFOR
#! IGNORED  </RelationKeyFields>
<FileKeyFields>
#FOR(%RelationKeyField)
  <FileKeyField>
    %(%WriteTag('Field', %GetStringValue(%RelationKeyField)))
    %(%WriteTag('FieldLink', %GetStringValue(%RelationKeyFieldLink)))
  </FileKeyField>
#ENDFOR
</FileKeyFields>
%(%WriteTag('QuickOptions', %GetQuickOptions(%RelationQuickOptions)))
%(%WriteTag('UserOptions', %GetUserOptions(%RelationUserOptions)))
%(%WriteTag('ToolOptions', %GetToolOptions(%RelationToolOptions)))
#!
#GROUP(%GetFileDriverInfo)
%(%WriteTag('Name', %GetStringValue(%Driver)))
%(%WriteTag('DllFile', %GetStringValue(%DriverDLL)))
%(%WriteTag('LibFile', %GetStringValue(%DriverLIB)))
%(%WriteTag('Description', %GetStringValue(%DriverDescription)))
%(%WriteTag('SupportsCreate', %GetBooleanValue(%DriverCreate)))
%(%WriteTag('SupportsOwner', %GetBooleanValue(%DriverOwner)))
%(%WriteTag('SupportsEncrypt', %GetBooleanValue(%DriverEncrypt)))
%(%WriteTag('SupportsReclaim', %GetBooleanValue(%DriverReclaim)))
%(%WriteTag('MaxKeys', %DriverMaxKeys))
%(%WriteTag('SupportsUniqueKey', %GetBooleanValue(%DriverUniqueKey)))
%(%WriteTag('SupportsDuplicateKey', %GetBooleanValue(%DriverRequired)))
%(%WriteTag('SupportsMemo', %GetBooleanValue(%DriverMemo)))
%(%WriteTag('SupportsBinaryMemo', %GetBooleanValue(%DriverBinMemo)))
%(%WriteTag('IsSql', %GetBooleanValue(%DriverSQL)))
%(%WriteTag('SupportsOem', %GetBooleanValue(%DriverOEM)))
<DataTypes>
#FOR(%DriverType)
  %(%WriteTag('DataType', %GetStringValue(%DriverType)))
#ENDFOR
</DataTypes>
<SupportedOperations>
#FOR(%DriverOpcode)
  %(%WriteTag('SupportedOperation', %GetStringValue(%DriverOpcode)))
#ENDFOR
</SupportedOperations>
#!-----------------------------------------------------------------------------
#GROUP(%Unsplit, %TheValue), AUTO
  #DECLARE(%sValue)
  #SET(%sValue, CLIP(LEFT(%TheValue)))
  #CALL(%ReplaceSubString, %sValue, ''' &|<13,10>   ''', '')
  #RETURN(%sValue)
#!
#GROUP(%ReplaceSubString, *%pString, %OldSubString, %NewSubString, %pCaseSensitive = 0), AUTO
  #DECLARE(%lPosition, LONG)
  #DECLARE(%lLen, LONG)
  #SET(%lPosition, 1)
  #SET(%lLen, LEN(%OldSubString))
  #LOOP
    #IF(%pCaseSensitive)
      #SET(%lPosition, INSTRING(%OldSubString, %pString, 1, %lPosition))
    #ELSE
      #SET(%lPosition, INSTRING(UPPER(%OldSubString), UPPER(%pString), 1, %lPosition))
    #ENDIF
    #IF(%lPosition = 0)
      #BREAK
    #ELSE
      #SET(%pString, SUB(%pString, 1, %lPosition - 1) & %NewSubString & SUB(%pString, %lPosition + %lLen, LEN(CLIP(%pString)) - %lPosition))
      #SET(%lPosition, %lPosition + LEN(%NewSubString))
    #ENDIF
  #ENDLOOP
#!
#GROUP(%WriteTag, %TagName, %TheValue)
  #RETURN('<<' & %TagName & '>' & %TheValue & '<</' & %TagName & '>')
#!
#GROUP(%GetStringValue, %TheValue), AUTO
  #DECLARE(%sValue)
  #SET(%sValue, CLIP(LEFT(%TheValue)))
  #CALL(%ReplaceSubString, %sValue, '&', '&amp;')
  #CALL(%ReplaceSubString, %sValue, '<<', '&lt;')
  #CALL(%ReplaceSubString, %sValue, '>', '&gt;')
  #CALL(%ReplaceSubString, %sValue, '"', '&quot;')
  #CALL(%ReplaceSubString, %sValue, '''', '&apos;')
  #RETURN(%sValue)
#!
#GROUP(%GetTimeValue, %TheTime)
  #RETURN(CLIP(LEFT(FORMAT(%TheTime, @T3))))
#!
#GROUP(%GetDateValue, %TheDate)
  #RETURN(CLIP(LEFT(FORMAT(%TheDate, @D2))))
#!
#GROUP(%GetBooleanValue, %TheValue)
  #RETURN(CHOOSE(%TheValue = '1', 'true', 'false'))
#!
#GROUP(%GetVersionInfo, %TheVersion)
  #RETURN(%TheVersion)
#!
#GROUP(%GetQuickOptions, %TheOptions)
  #RETURN(%TheOptions)
#!
#GROUP(%GetUserOptions, %TheOptions)
  #RETURN(%TheOptions)
#!
#GROUP(%GetToolOptions, %TheOptions)
  #RETURN(%TheOptions)
#!
#GROUP(%GetEncoding, %TheValue)
  #RETURN(CHOOSE(CLIP(LEFT(%TheValue)) <> '', 'encoding="' & %TheValue & '"', ''))
#!
#GROUP(%Notice)
#BOXED('--- NOTICE ---')
  #DISPLAY('You may use this template in any manner you wish.')
  #DISPLAY('I am not responsible for any damage it may cause.')
  #DISPLAY('You may NOT sell this template in any form,')
  #DISPLAY('     without my express written permission.')
  #DISPLAY()
  #DISPLAY('Corrections and suggestions are welcome.')
  #DISPLAY()
  #DISPLAY('Author: Harley H. Jones')
  #DISPLAY('Email: harley.333@gmail.com')
  #PROMPT('Updated: ', @D4), %pDateModified, PROP(PROP:Readonly, 1), PROP(PROP:Trn, 1), PROP(PROP:Skip, 1)
#ENDBOXED
